# file: anonymized_log_format.conf
# remove the last octet of the remote_addr IP address
map $remote_addr $ip_anon1 {
    default 0.0.0;
    "~(?P<ip>(\d+)\.(\d+))\.(\d+)\.\d+" $ip;
    "~(?P<ip>[^:]+:[^:]+):" $ip;
}

map $remote_addr $ip_anon2 {
    default .0.0;
    "~(?P<ip>(\d+)\.(\d+)\.(\d+))\.\d+" .0.0;
    "~(?P<ip>[^:]+:[^:]+):" ::;
}

map $ip_anon1$ip_anon2 $ip_anonymized {
    default 0.0.0.0;
    "~(?P<ip>.*)" $ip;
}

log_format anonymized '$ip_anonymized - $remote_user [$time_local] '
'"$request" $status $body_bytes_sent '
'"$http_referer" "$http_user_agent"';
# end of file: anonymized_log_format.conf
